local oldReputationFrame_Update;

function DWMRepColoredBars_OnLoad(self)

oldReputationFrame_Update = ReputationFrame_Update;
ReputationFrame_Update = DWMRepColoredBarsFrame_Update;

end

FACTION_BAR_COLORS = {
	[1] = {r = 1.0, g = 0, b = 0},	                	-- 36000 Hated - Red
	[2] = {r = 1.0, g = 0.5019608, b = 0},	        -- 3000 Hostile - Orange
	[3] = {r = 1.0, g = 0.8196079, b = 0},	        -- 3000 Unfriendly - Yellow
	[4] = {r = 0.8, g = 0.9, b = 0.8},    	        	-- 3000 Neutral - Gray
	[5] = {r = 0.90196, g = 0.8, b = 0.50196},	-- 6000 Friendly - Tan
	[6] = {r = 0, g = 0.6, b = 0.1},	            		-- 12000 Honored - Green
	[7] = {r = 0, g = 0, b = 1.0},	                	-- 21000 Revered - Blue
	[8] = {r = 0.5803922, g = 0, b = 0.827451}, 	-- 1000 Exalted - Purple
};

function DWMRepColoredBarsFrame_OnLoad (self)
    self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("UNIT_NAME_UPDATE");
	self:RegisterEvent("UNIT_PORTRAIT_UPDATE");
	self:RegisterEvent("PLAYER_PVP_RANK_CHANGED");
    self:RegisterEvent("ADDON_LOADED"); 
    self:RegisterEvent("PLAYER_LOGOUT"); 
    self:RegisterEvent("PLAYER_ENTERING_WORLD");
    self:RegisterEvent("UPDATE_FACTION");
end

function DWMRepColoredBarsFrame_OnShow()
	DWMRepColoredBarsFrame_Update();
end

function DWMRepColoredBarsFrame_OnEvent(self, event, ...)
	if ( event == "UPDATE_FACTION" ) then
		if ( self:IsVisible() ) then
			DWMRepColoredBarsFrame_Update();
		end
	end
end

function DWMRepColoredBarsFrameWatchBar_Update(newLevel)
	local name, reaction, min, max, value = GetWatchedFactionInfo();
 	local visibilityChanged = nil;
	if ( not newLevel ) then
		newLevel = UnitLevel("player");
	end
	if ( name ) then
		-- See if it was already shown or not
		if ( not ReputationWatchBar:IsShown() ) then
			visibilityChanged = 1;
		end
		-- Normalize values
		max = max - min;
		value = value - min;
		min = 0;
            
        if ((barValue-barMin) >= 0) then
		ReputationWatchStatusBar:SetMinMaxValues(min, max);
		ReputationWatchStatusBar:SetValue(value);
		ReputationWatchStatusBarText:SetText(name);
		local color = FACTION_BAR_COLORS[reaction];
		ReputationWatchStatusBar:SetStatusBarColor(color.r, color.g, color.b);
		ReputationWatchBar:Show();
	end
end
end

